/*
 * Basé sur la vidéo https://youtu.be/U2u1jvcUXBc
 */
  //Déclaration des constantes
  const int led=13;                    /*Nous piloterons la led BUILDIN des cartes Arduino
                                        (câblée par défaut sur la broche 13)*/
  const int pot=A0;                    /*le potentiomètre de consigne est connecté à la broche
                                         analogique A0
                                         (Potentiomètre : Broche 1 --> +5V, Broche 2--> A0
                                         et Broche 3-->GND)*/

void setup() {
  Serial.begin(115200);                  /* Ouverture de la commnication série à 9600 Bauds */
  pinMode(led,OUTPUT);                 /* led configurée en SORTIE*/
  pinMode(pot,INPUT);                  /* pot configurée en ENTREE*/
  digitalWrite(led,LOW);               /* on s'assure que la led est éteinte 
                                          à la mise sous tension */

}

void loop() {
  //Température
  int t=random(20,32);                  /* génération aléatoire d'un nombre entre 20 et 32 */
  //Humidité
  int h = random (60,100);              /* génération aléatoire d'un nombre entre 60 et 100 */
  //Consigne en %
  int valPot=analogRead(A0);            /* sockage de la valeur lue sur l'entrée A0 dans la 
                                           variable valPot*/
  valPot=map(valPot,0,1023,0,100);      /* mise à l'échelle de la valPot 0-->0% et 1023-->100%*/

 /*Vérification si des valeurs arrivent dans le buffer de la carte Arduino*/
  if (Serial.available()!=0){               /* S'il y a quelque chose dans le buffer...*/
    String commande=Serial.readString();  /* Alors on lit la chaîne de caractère arrivée
                                             dans le buffer */
    if (commande=="ON"){                  /* Si commande est égale à la chaîne de caractère "ON" */      
      digitalWrite(led, HIGH);            /* Alors on allume la led */
    }
    else if (commande=="OFF"){            /* Si commande est égale à la chaîne de caractère "OFF" */
      digitalWrite(led,LOW);              /* Alors on éteint la led */
    }
  }

  /*Remarquer qu'on peut pas envoyer les messages à node red
    sans le retour à la ligne \n ou println */
  Serial.print("t=");         /* On envoie sur le port série la chaîne de caractère "t=" */
  Serial.println(t);          /* On envoie sur le port série la valeur de la variable t */

  Serial.print("h=");         /* On envoie sur le port série la chaîne de caractère "h=" */
  Serial.println(h);          /* On envoie sur le port série la valeur de la variable h */
  
  Serial.print("Consigne=");  /* On envoie sur le port sériela chaîne de caractère "Consigne=" */
  Serial.println(valPot);     /* On envoie sur le port série la valeur de la variable valPot */

  Serial.println();           /* Ajout d'un saut de ligne */

  delay(1000);              
  
}
